module FFJPL.FieldLookup where {
	import FFJ.Syntax;
	import FFJPL.Definitions;
	import FFJPL.Functions;
	import FFJPL.FeatureModel;
	import FFJPL.Navigation;
	import Debug.Trace;
	
	fields :: FeatureModel -> CT -> [Feature] -> ExtType -> [[Field]];
	fields fm ct omegas (c,phi) | (c == "Object") = [[]]
								| (never fm omegas phi) = fields fm ct omegas (getPred ct (c,phi))
								| (sometimes fm omegas phi) && ((alwaysGroup fm omegas phi) == []) = case (getClass ct (c,phi)) of {
								                                                                        (True,_,_,[],_) -> (fields fm ct omegas (getPred ct (c,phi)));
								                                                                        (False,_,d,[],_) -> (fields fm ct omegas (getLast ct d));
								                                                                        (True,_,_,fs,_) -> (trace ("Found optional feature in field lookup: " ++ (show phi))) (append (fields fm ct omegas (getPred ct (c,phi))) fs);
								                                                                        (False,_,d,fs,_) -> (trace ("Found optional feature in field lookup: " ++ (show phi))) (append (fields fm ct omegas (getLast ct d)) fs);
								                                                                     }
								| (sometimes fm omegas phi) && ((alwaysGroup fm omegas phi) == [phi]) = case (getClass ct (c,phi)) of {
								                                                                          (True,_,_,fs,_) -> (append (fields fm ct omegas (getPred ct (c,phi))) fs);
								                                                                          (False,_,d,fs,_) -> (append (fields fm ct omegas (getLast ct d)) fs);
								                                                                        }
		                        | (sometimes fm omegas phi) && (length (alwaysGroup fm omegas phi) > 1) = concatMap (\psi -> fields fm ct (omegas++[psi]) (c,phi)) (alwaysGroup fm omegas phi); -- multiFields fm ct omegas (c,phi) (alwaysGroup fm omegas phi);
		                                                                                                 
	append :: [[a]] -> [a] -> [[a]];
	append (list:lists) add = ((list++add):(append lists add));
	append [] _ = [];
}