module FFJPL.Programs where {
	import FFJ.Syntax;
	import FFJPL.Definitions;
	import FFJPL.Functions;
	import FFJPL.FeatureModel;
	import FFJPL.Navigation;
	import FFJPL.Subtype;
	import FFJPL.TermTyping;
	import Maybe;	
	import Debug.Trace;

	programsOK :: FeatureModel -> CT -> PT -> Bool;
	programsOK fm ct (p:ps) = (programOK fm ct p) && (programsOK fm ct ps);
	programsOK _ _ [] = True;

	programOK :: FeatureModel -> CT -> (PTEntry, Term) -> Bool;
	programOK fm ct ((c,(v,phi)),t) = if (and (map (\d -> isSubType fm ct d c [phi]) (getTermType fm ct [] t phi))) then True else error ("Type error: Program: " ++ phi ++ "::" ++ "v" ++ " with type " ++ c ++ " is not well-formed!");
}