
module FJ.Program where {
	import FJ.Syntax;
	import Maybe;
	
	type CTEntry = Type;
	type CT = [(CTEntry, Class)];
	
	classdef :: CT -> CTEntry -> Maybe Class;
	classdef ct c = lookup c ct;

	initct :: CT;
	initct = [("Object", ("Object", "", ("", [], [], []), [], []))];
	
	type PTEntry = (Type,Identifier);
	type PT = [(PTEntry, Term)];
	
	initpt :: PT;
	initpt = [];
	
	subtypes :: CT -> [Type] -> [Type] -> Bool;
	subtypes ct (c:cs) (d:ds) = (subtype ct c d) && (subtypes ct cs ds);
	subtypes ct [] [] = True;
	
	subtype :: CT -> Type -> Type -> Bool;
	subtype ct c d | (c == d) = True 
	               | (c == "Object") = False 
	               | otherwise = if (isJust cd) then (if (d == sc) then True else (subtype ct sc d)) else error ("Class declaration of " ++ c ++ " does not exist!")
	               where { cd = (classdef ct c); sc = superclass (fromJust cd) };
	
	superclass :: Class -> Type;
	superclass (_,d,_,_,_) = d;
}